//
// InternetTracking.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct InternetTracking: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var actorKeyNumeric: Double?
    public var actorLatitude: Double?
    public var actorLongitude: Double?
    public var colorDepth: Double?
    public var eventKeyNumeric: Double?
    public var objectKeyNumeric: Double?
    public var screenHeight: Double?
    public var screenWidth: Double?
    public var timeZoneOffset: Double?
    public var actorCity: String?
    public var actorEmail: String?
    public var actorID: String?
    public var actorIP: String?
    public var actorKey: String?
    public var actorOriginatingSystemID: Double?
    public var actorOriginatingSystemName: String?
    public var actorPhone: String?
    public var actorPhoneExt: String?
    public var actorPostalCode: String?
    public var actorPostalCodePlus4: String?
    public var actorRegion: String?
    public var actorSourceSystemID: Double?
    public var actorSourceSystemName: String?
    public var eventDescription: String?
    public var eventKey: String?
    public var eventLabel: String?
    public var eventOriginatingSystemID: Double?
    public var eventOriginatingSystemName: String?
    public var eventSourceSystemID: Double?
    public var eventSourceSystemName: String?
    public var objectID: String?
    public var objectKey: String?
    public var objectOriginatingSystemID: Double?
    public var objectOriginatingSystemName: String?
    public var objectSourceSystemID: Double?
    public var objectSourceSystemName: String?
    public var objectURL: String?
    public var originatingSystemActorKey: String?
    public var originatingSystemEventKey: String?
    public var originatingSystemObjectKey: String?
    public var referringURL: String?
    public var sessionID: String?
    public var sourceSystemActorKey: String?
    public var sourceSystemEventKey: String?
    public var sourceSystemObjectKey: String?
    public var userAgent: String?
    public var actorStateOrProvince: String?
    public var actorType: String?
    public var deviceType: String?
    public var eventTarget: String?
    public var eventType: String?
    public var objectIdType: String?
    public var objectType: String?
    public var eventTimestamp: Date?
    public var actorOriginatingSystem: OUID?
    public var actorSourceSystem: OUID?
    public var eventOriginatingSystem: OUID?
    public var eventSourceSystem: OUID?
    public var objectOriginatingSystem: OUID?
    public var objectSourceSystem: OUID?

    public init(id: Int? = nil, actorKeyNumeric: Double? = nil, actorLatitude: Double? = nil, actorLongitude: Double? = nil, colorDepth: Double? = nil, eventKeyNumeric: Double? = nil, objectKeyNumeric: Double? = nil, screenHeight: Double? = nil, screenWidth: Double? = nil, timeZoneOffset: Double? = nil, actorCity: String? = nil, actorEmail: String? = nil, actorID: String? = nil, actorIP: String? = nil, actorKey: String? = nil, actorOriginatingSystemID: Double? = nil, actorOriginatingSystemName: String? = nil, actorPhone: String? = nil, actorPhoneExt: String? = nil, actorPostalCode: String? = nil, actorPostalCodePlus4: String? = nil, actorRegion: String? = nil, actorSourceSystemID: Double? = nil, actorSourceSystemName: String? = nil, eventDescription: String? = nil, eventKey: String? = nil, eventLabel: String? = nil, eventOriginatingSystemID: Double? = nil, eventOriginatingSystemName: String? = nil, eventSourceSystemID: Double? = nil, eventSourceSystemName: String? = nil, objectID: String? = nil, objectKey: String? = nil, objectOriginatingSystemID: Double? = nil, objectOriginatingSystemName: String? = nil, objectSourceSystemID: Double? = nil, objectSourceSystemName: String? = nil, objectURL: String? = nil, originatingSystemActorKey: String? = nil, originatingSystemEventKey: String? = nil, originatingSystemObjectKey: String? = nil, referringURL: String? = nil, sessionID: String? = nil, sourceSystemActorKey: String? = nil, sourceSystemEventKey: String? = nil, sourceSystemObjectKey: String? = nil, userAgent: String? = nil, actorStateOrProvince: String? = nil, actorType: String? = nil, deviceType: String? = nil, eventTarget: String? = nil, eventType: String? = nil, objectIdType: String? = nil, objectType: String? = nil, eventTimestamp: Date? = nil, actorOriginatingSystem: OUID? = nil, actorSourceSystem: OUID? = nil, eventOriginatingSystem: OUID? = nil, eventSourceSystem: OUID? = nil, objectOriginatingSystem: OUID? = nil, objectSourceSystem: OUID? = nil) {
        self.id = id
        self.actorKeyNumeric = actorKeyNumeric
        self.actorLatitude = actorLatitude
        self.actorLongitude = actorLongitude
        self.colorDepth = colorDepth
        self.eventKeyNumeric = eventKeyNumeric
        self.objectKeyNumeric = objectKeyNumeric
        self.screenHeight = screenHeight
        self.screenWidth = screenWidth
        self.timeZoneOffset = timeZoneOffset
        self.actorCity = actorCity
        self.actorEmail = actorEmail
        self.actorID = actorID
        self.actorIP = actorIP
        self.actorKey = actorKey
        self.actorOriginatingSystemID = actorOriginatingSystemID
        self.actorOriginatingSystemName = actorOriginatingSystemName
        self.actorPhone = actorPhone
        self.actorPhoneExt = actorPhoneExt
        self.actorPostalCode = actorPostalCode
        self.actorPostalCodePlus4 = actorPostalCodePlus4
        self.actorRegion = actorRegion
        self.actorSourceSystemID = actorSourceSystemID
        self.actorSourceSystemName = actorSourceSystemName
        self.eventDescription = eventDescription
        self.eventKey = eventKey
        self.eventLabel = eventLabel
        self.eventOriginatingSystemID = eventOriginatingSystemID
        self.eventOriginatingSystemName = eventOriginatingSystemName
        self.eventSourceSystemID = eventSourceSystemID
        self.eventSourceSystemName = eventSourceSystemName
        self.objectID = objectID
        self.objectKey = objectKey
        self.objectOriginatingSystemID = objectOriginatingSystemID
        self.objectOriginatingSystemName = objectOriginatingSystemName
        self.objectSourceSystemID = objectSourceSystemID
        self.objectSourceSystemName = objectSourceSystemName
        self.objectURL = objectURL
        self.originatingSystemActorKey = originatingSystemActorKey
        self.originatingSystemEventKey = originatingSystemEventKey
        self.originatingSystemObjectKey = originatingSystemObjectKey
        self.referringURL = referringURL
        self.sessionID = sessionID
        self.sourceSystemActorKey = sourceSystemActorKey
        self.sourceSystemEventKey = sourceSystemEventKey
        self.sourceSystemObjectKey = sourceSystemObjectKey
        self.userAgent = userAgent
        self.actorStateOrProvince = actorStateOrProvince
        self.actorType = actorType
        self.deviceType = deviceType
        self.eventTarget = eventTarget
        self.eventType = eventType
        self.objectIdType = objectIdType
        self.objectType = objectType
        self.eventTimestamp = eventTimestamp
        self.actorOriginatingSystem = actorOriginatingSystem
        self.actorSourceSystem = actorSourceSystem
        self.eventOriginatingSystem = eventOriginatingSystem
        self.eventSourceSystem = eventSourceSystem
        self.objectOriginatingSystem = objectOriginatingSystem
        self.objectSourceSystem = objectSourceSystem
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case actorKeyNumeric = "ActorKeyNumeric"
        case actorLatitude = "ActorLatitude"
        case actorLongitude = "ActorLongitude"
        case colorDepth = "ColorDepth"
        case eventKeyNumeric = "EventKeyNumeric"
        case objectKeyNumeric = "ObjectKeyNumeric"
        case screenHeight = "ScreenHeight"
        case screenWidth = "ScreenWidth"
        case timeZoneOffset = "TimeZoneOffset"
        case actorCity = "ActorCity"
        case actorEmail = "ActorEmail"
        case actorID = "ActorID"
        case actorIP = "ActorIP"
        case actorKey = "ActorKey"
        case actorOriginatingSystemID = "ActorOriginatingSystemID"
        case actorOriginatingSystemName = "ActorOriginatingSystemName"
        case actorPhone = "ActorPhone"
        case actorPhoneExt = "ActorPhoneExt"
        case actorPostalCode = "ActorPostalCode"
        case actorPostalCodePlus4 = "ActorPostalCodePlus4"
        case actorRegion = "ActorRegion"
        case actorSourceSystemID = "ActorSourceSystemID"
        case actorSourceSystemName = "ActorSourceSystemName"
        case eventDescription = "EventDescription"
        case eventKey = "EventKey"
        case eventLabel = "EventLabel"
        case eventOriginatingSystemID = "EventOriginatingSystemID"
        case eventOriginatingSystemName = "EventOriginatingSystemName"
        case eventSourceSystemID = "EventSourceSystemID"
        case eventSourceSystemName = "EventSourceSystemName"
        case objectID = "ObjectID"
        case objectKey = "ObjectKey"
        case objectOriginatingSystemID = "ObjectOriginatingSystemID"
        case objectOriginatingSystemName = "ObjectOriginatingSystemName"
        case objectSourceSystemID = "ObjectSourceSystemID"
        case objectSourceSystemName = "ObjectSourceSystemName"
        case objectURL = "ObjectURL"
        case originatingSystemActorKey = "OriginatingSystemActorKey"
        case originatingSystemEventKey = "OriginatingSystemEventKey"
        case originatingSystemObjectKey = "OriginatingSystemObjectKey"
        case referringURL = "ReferringURL"
        case sessionID = "SessionID"
        case sourceSystemActorKey = "SourceSystemActorKey"
        case sourceSystemEventKey = "SourceSystemEventKey"
        case sourceSystemObjectKey = "SourceSystemObjectKey"
        case userAgent = "UserAgent"
        case actorStateOrProvince = "ActorStateOrProvince"
        case actorType = "ActorType"
        case deviceType = "DeviceType"
        case eventTarget = "EventTarget"
        case eventType = "EventType"
        case objectIdType = "ObjectIdType"
        case objectType = "ObjectType"
        case eventTimestamp = "EventTimestamp"
        case actorOriginatingSystem = "ActorOriginatingSystem"
        case actorSourceSystem = "ActorSourceSystem"
        case eventOriginatingSystem = "EventOriginatingSystem"
        case eventSourceSystem = "EventSourceSystem"
        case objectOriginatingSystem = "ObjectOriginatingSystem"
        case objectSourceSystem = "ObjectSourceSystem"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(actorKeyNumeric, forKey: .actorKeyNumeric)
        try container.encodeIfPresent(actorLatitude, forKey: .actorLatitude)
        try container.encodeIfPresent(actorLongitude, forKey: .actorLongitude)
        try container.encodeIfPresent(colorDepth, forKey: .colorDepth)
        try container.encodeIfPresent(eventKeyNumeric, forKey: .eventKeyNumeric)
        try container.encodeIfPresent(objectKeyNumeric, forKey: .objectKeyNumeric)
        try container.encodeIfPresent(screenHeight, forKey: .screenHeight)
        try container.encodeIfPresent(screenWidth, forKey: .screenWidth)
        try container.encodeIfPresent(timeZoneOffset, forKey: .timeZoneOffset)
        try container.encodeIfPresent(actorCity, forKey: .actorCity)
        try container.encodeIfPresent(actorEmail, forKey: .actorEmail)
        try container.encodeIfPresent(actorID, forKey: .actorID)
        try container.encodeIfPresent(actorIP, forKey: .actorIP)
        try container.encodeIfPresent(actorKey, forKey: .actorKey)
        try container.encodeIfPresent(actorOriginatingSystemID, forKey: .actorOriginatingSystemID)
        try container.encodeIfPresent(actorOriginatingSystemName, forKey: .actorOriginatingSystemName)
        try container.encodeIfPresent(actorPhone, forKey: .actorPhone)
        try container.encodeIfPresent(actorPhoneExt, forKey: .actorPhoneExt)
        try container.encodeIfPresent(actorPostalCode, forKey: .actorPostalCode)
        try container.encodeIfPresent(actorPostalCodePlus4, forKey: .actorPostalCodePlus4)
        try container.encodeIfPresent(actorRegion, forKey: .actorRegion)
        try container.encodeIfPresent(actorSourceSystemID, forKey: .actorSourceSystemID)
        try container.encodeIfPresent(actorSourceSystemName, forKey: .actorSourceSystemName)
        try container.encodeIfPresent(eventDescription, forKey: .eventDescription)
        try container.encodeIfPresent(eventKey, forKey: .eventKey)
        try container.encodeIfPresent(eventLabel, forKey: .eventLabel)
        try container.encodeIfPresent(eventOriginatingSystemID, forKey: .eventOriginatingSystemID)
        try container.encodeIfPresent(eventOriginatingSystemName, forKey: .eventOriginatingSystemName)
        try container.encodeIfPresent(eventSourceSystemID, forKey: .eventSourceSystemID)
        try container.encodeIfPresent(eventSourceSystemName, forKey: .eventSourceSystemName)
        try container.encodeIfPresent(objectID, forKey: .objectID)
        try container.encodeIfPresent(objectKey, forKey: .objectKey)
        try container.encodeIfPresent(objectOriginatingSystemID, forKey: .objectOriginatingSystemID)
        try container.encodeIfPresent(objectOriginatingSystemName, forKey: .objectOriginatingSystemName)
        try container.encodeIfPresent(objectSourceSystemID, forKey: .objectSourceSystemID)
        try container.encodeIfPresent(objectSourceSystemName, forKey: .objectSourceSystemName)
        try container.encodeIfPresent(objectURL, forKey: .objectURL)
        try container.encodeIfPresent(originatingSystemActorKey, forKey: .originatingSystemActorKey)
        try container.encodeIfPresent(originatingSystemEventKey, forKey: .originatingSystemEventKey)
        try container.encodeIfPresent(originatingSystemObjectKey, forKey: .originatingSystemObjectKey)
        try container.encodeIfPresent(referringURL, forKey: .referringURL)
        try container.encodeIfPresent(sessionID, forKey: .sessionID)
        try container.encodeIfPresent(sourceSystemActorKey, forKey: .sourceSystemActorKey)
        try container.encodeIfPresent(sourceSystemEventKey, forKey: .sourceSystemEventKey)
        try container.encodeIfPresent(sourceSystemObjectKey, forKey: .sourceSystemObjectKey)
        try container.encodeIfPresent(userAgent, forKey: .userAgent)
        try container.encodeIfPresent(actorStateOrProvince, forKey: .actorStateOrProvince)
        try container.encodeIfPresent(actorType, forKey: .actorType)
        try container.encodeIfPresent(deviceType, forKey: .deviceType)
        try container.encodeIfPresent(eventTarget, forKey: .eventTarget)
        try container.encodeIfPresent(eventType, forKey: .eventType)
        try container.encodeIfPresent(objectIdType, forKey: .objectIdType)
        try container.encodeIfPresent(objectType, forKey: .objectType)
        try container.encodeIfPresent(eventTimestamp, forKey: .eventTimestamp)
        try container.encodeIfPresent(actorOriginatingSystem, forKey: .actorOriginatingSystem)
        try container.encodeIfPresent(actorSourceSystem, forKey: .actorSourceSystem)
        try container.encodeIfPresent(eventOriginatingSystem, forKey: .eventOriginatingSystem)
        try container.encodeIfPresent(eventSourceSystem, forKey: .eventSourceSystem)
        try container.encodeIfPresent(objectOriginatingSystem, forKey: .objectOriginatingSystem)
        try container.encodeIfPresent(objectSourceSystem, forKey: .objectSourceSystem)
    }
}

